Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Map_Manager_Adapter Class Template Reference

Defines a map implementation. More...

`#include <Map_T.h>`

Inheritance diagram for ACE_Map_Manager_Adapter:

[legend]
Collaboration diagram for ACE_Map_Manager_Adapter:

[legend]
List of all members.

## Public Types
typedef ACE_Map_Manager_Iterator_Adapter< ACE_Reference_Pair< const KEY, VALUE >, KEY, VALUE > | iterator_impl
typedef ACE_Map_Manager_Reverse_Iterator_Adapter< ACE_Reference_Pair< const KEY, VALUE >, KEY, VALUE > | reverse_iterator_impl
typedef ACE_Map_Manager< KEY, VALUE, ACE_Null_Mutex > | implementation
## Public Methods
| ACE_Map_Manager_Adapter (ACE_Allocator *alloc=0)
| Initialize with the <ACE_DEFAULT_MAP_SIZE>. More...
| ACE_Map_Manager_Adapter (size_t size, ACE_Allocator *alloc=0)
| Initialize with <size> entries. The <size> parameter is ignored by maps for which an initialize size does not make sense. More...
virtual | ~ACE_Map_Manager_Adapter (void)
| Close down and release dynamically allocated resources. More...
virtual int | open (size_t length=ACE_DEFAULT_MAP_SIZE, ACE_Allocator *alloc=0)
| Initialize a <Map> with size <length>. More...
virtual int | close (void)
| Close down a <Map> and release dynamically allocated resources. More...
virtual int | bind (const KEY &key, const VALUE &value)
| Add <key>/<value> pair to the map. More...
virtual int | bind_modify_key (const VALUE &value, KEY &key)
| Add <key>/<value> pair to the map. More...
virtual int | create_key (KEY &key)
| Produce a key and return it through <key> which is an "out" parameter. More...
virtual int | bind_create_key (const VALUE &value, KEY &key)
| Add <value> to the map, and the corresponding key produced by the Map is returned through <key> which is an "out" parameter. More...
virtual int | bind_create_key (const VALUE &value)
| Add <value> to the map. More...
virtual int | recover_key (const KEY &modified_key, KEY &original_key)
| Recovers the original key potentially modified by the map during <bind_modify_key>. More...
virtual int | rebind (const KEY &key, const VALUE &value)
| Reassociate <key> with <value>. More...
virtual int | rebind (const KEY &key, const VALUE &value, VALUE &old_value)
| Reassociate <key> with <value>, storing the old value into the "out" parameter. More...
virtual int | rebind (const KEY &key, const VALUE &value, KEY &old_key, VALUE &old_value)
| Reassociate <key> with <value>, storing the old key and value into the "out" parameters. More...
virtual int | trybind (const KEY &key, VALUE &value)
| Associate <key> with <value> if and only if <key> is not in the map. More...
virtual int | find (const KEY &key, VALUE &value)
| Locate <value> associated with <key>. More...
virtual int | find (const KEY &key)
| Is <key> in the map? More...
virtual int | unbind (const KEY &key)
| Remove <key> from the map. More...
virtual int | unbind (const KEY &key, VALUE &value)
| Remove <key> from the map, and return the <value> associated with <key>. More...
virtual size_t | current_size (void) const
| Return the current size of the map. More...
virtual size_t | total_size (void) const
| Return the total size of the map. More...
virtual void | dump (void) const
| Dump the state of an object. More...
ACE_Map_Manager< KEY, VALUE, ACE_Null_Mutex > & | impl (void)
| Accessor to implementation object. More...
KEY_GENERATOR & | key_generator (void)
| Accessor to key generator. More...
## Protected Methods
virtual ACE_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * | begin_impl (void)
| Return forward iterator. More...
virtual ACE_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * | end_impl (void)
virtual ACE_Reverse_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * | rbegin_impl (void)
| Return reverse iterator. More...
virtual ACE_Reverse_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * | rend_impl (void)
## Protected Attributes
ACE_Map_Manager< KEY, VALUE, ACE_Null_Mutex > | implementation_
| All implementation details are forwarded to this class. More...
KEY_GENERATOR | key_generator_
| Functor class used for generating key. More...
## Private Methods
void | operator= (const ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR > &)
| ACE_Map_Manager_Adapter (const ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR > &)

## Detailed Description

### template<class KEY, class VALUE, class KEY_GENERATOR>
class ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >

Defines a map implementation.

Implementation to be provided by <ACE_Map_Manager>.

## Member Typedef Documentation

template<class KEY, class VALUE, class KEY_GENERATOR>
typedef ACE_Map_Manager<KEY, VALUE, ACE_Null_Mutex> ACE_Map_Manager_Adapter::implementation

template<class KEY, class VALUE, class KEY_GENERATOR>
typedef ACE_Map_Manager_Iterator_Adapter<ACE_Reference_Pair<const KEY, VALUE>, KEY, VALUE> ACE_Map_Manager_Adapter::iterator_impl

template<class KEY, class VALUE, class KEY_GENERATOR>
typedef ACE_Map_Manager_Reverse_Iterator_Adapter<ACE_Reference_Pair<const KEY, VALUE>, KEY, VALUE> ACE_Map_Manager_Adapter::reverse_iterator_impl

## Constructor & Destructor Documentation

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::ACE_Map_Manager_Adapter | ( | ACE_Allocator * | alloc = 0 | ) |

| Initialize with the <ACE_DEFAULT_MAP_SIZE>.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::ACE_Map_Manager_Adapter | ( | size_t | size,
|  | ACE_Allocator * | alloc = 0
| ) |

| Initialize with <size> entries. The <size> parameter is ignored by maps for which an initialize size does not make sense.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::~ACE_Map_Manager_Adapter | ( | void |  | ) | `[virtual]`

| Close down and release dynamically allocated resources.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::ACE_Map_Manager_Adapter | ( | const ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR > & |  | ) | `[private]`

## Member Function Documentation

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::begin_impl | ( | void |  | ) | `[protected, virtual]`

| Return forward iterator. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::bind | ( | const KEY & | key,
|  | const VALUE & | value
| ) | `[virtual]`

| Add <key>/<value> pair to the map. If <key> is already in the map then no changes are made and 1 is returned. Returns 0 on a successful addition. This function fails for maps that do not allow user specified keys. <key> is an "in" parameter. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::bind_create_key | ( | const VALUE & | value | ) | `[virtual]`

| Add <value> to the map. The user does not care about the corresponding key produced by the Map. For maps that do not naturally produce keys, the map adapters will use the <KEY_GENERATOR> class to produce a key. However, the users are responsible for not jeopardizing this key production scheme by using user specified keys with keys produced by the key generator. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::bind_create_key | ( | const VALUE & | value,
|  | KEY & | key
| ) | `[virtual]`

| Add <value> to the map, and the corresponding key produced by the Map is returned through <key> which is an "out" parameter. For maps that do not naturally produce keys, the map adapters will use the <KEY_GENERATOR> class to produce a key. However, the users are responsible for not jeopardizing this key production scheme by using user specified keys with keys produced by the key generator. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::bind_modify_key | ( | const VALUE & | value,
|  | KEY & | key
| ) | `[virtual]`

| Add <key>/<value> pair to the map. <key> is an "inout" parameter and maybe modified/extended by the map to add additional information. To recover original key, call the <recover_key> method. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::close | ( | void |  | ) | `[virtual]`

| Close down a <Map> and release dynamically allocated resources. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::create_key | ( | KEY & | key | ) | `[virtual]`

| Produce a key and return it through <key> which is an "out" parameter. For maps that do not naturally produce keys, the map adapters will use the <KEY_GENERATOR> class to produce a key. However, the users are responsible for not jeopardizing this key production scheme by using user specified keys with keys produced by the key generator. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE size_t ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::current_size | ( | void |  | ) | const`[virtual]`

| Return the current size of the map. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE void ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::dump | ( | void |  | ) | const`[virtual]`

| Dump the state of an object. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::end_impl | ( | void |  | ) | `[protected, virtual]`

| Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::find | ( | const KEY & | key | ) | `[virtual]`

| Is <key> in the map? Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::find | ( | const KEY & | key,
|  | VALUE & | value
| ) | `[virtual]`

| Locate <value> associated with <key>. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Map_Manager< KEY, VALUE, ACE_Null_Mutex > & ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::impl | ( | void |  | ) |

| Accessor to implementation object.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE KEY_GENERATOR & ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::key_generator | ( | void |  | ) |

| Accessor to key generator.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::open | ( | size_t | length = ACE_DEFAULT_MAP_SIZE,
|  | ACE_Allocator * | alloc = 0
| ) | `[virtual]`

| Initialize a <Map> with size <length>. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
void ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::operator= | ( | const ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR > & |  | ) | `[private]`

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Reverse_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::rbegin_impl | ( | void |  | ) | `[protected, virtual]`

| Return reverse iterator. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::rebind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | KEY & | old_key,
|  | VALUE & | old_value
| ) | `[virtual]`

| Reassociate <key> with <value>, storing the old key and value into the "out" parameters. <old_key> and <old_value>. The function fails if <key> is not in the map for maps that do not allow user specified keys. However, for maps that allow user specified keys, if the key is not in the map, a new <key>/<value> association is created. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::rebind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | VALUE & | old_value
| ) | `[virtual]`

| Reassociate <key> with <value>, storing the old value into the "out" parameter. <old_value>. The function fails if <key> is not in the map for maps that do not allow user specified keys. However, for maps that allow user specified keys, if the key is not in the map, a new <key>/<value> association is created. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::rebind | ( | const KEY & | key,
|  | const VALUE & | value
| ) | `[virtual]`

| Reassociate <key> with <value>. The function fails if <key> is not in the map for maps that do not allow user specified keys. However, for maps that allow user specified keys, if the key is not in the map, a new <key>/<value> association is created. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::recover_key | ( | const KEY & | modified_key,
|  | KEY & | original_key
| ) | `[virtual]`

| Recovers the original key potentially modified by the map during <bind_modify_key>. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE ACE_Reverse_Iterator_Impl< ACE_Reference_Pair< const KEY, VALUE > > * ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::rend_impl | ( | void |  | ) | `[protected, virtual]`

| Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE size_t ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::total_size | ( | void |  | ) | const`[virtual]`

| Return the total size of the map. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::trybind | ( | const KEY & | key,
|  | VALUE & | value
| ) | `[virtual]`

| Associate <key> with <value> if and only if <key> is not in the map. If <key> is already in the map, then the <value> parameter is overwritten with the existing value in the map. Returns 0 if a new <key>/<value> association is created. Returns 1 if an attempt is made to bind an existing entry. This function fails for maps that do not allow user specified keys. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::unbind | ( | const KEY & | key,
|  | VALUE & | value
| ) | `[virtual]`

| Remove <key> from the map, and return the <value> associated with <key>. Reimplemented from ACE_Map.

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_INLINE int ACE_Map_Manager_Adapter< KEY, VALUE, KEY_GENERATOR >::unbind | ( | const KEY & | key | ) | `[virtual]`

| Remove <key> from the map. Reimplemented from ACE_Map.

## Member Data Documentation

template<class KEY, class VALUE, class KEY_GENERATOR>
ACE_Map_Manager<KEY, VALUE, ACE_Null_Mutex> ACE_Map_Manager_Adapter::implementation_`[protected]`

| All implementation details are forwarded to this class.

template<class KEY, class VALUE, class KEY_GENERATOR>
KEY_GENERATOR ACE_Map_Manager_Adapter::key_generator_`[protected]`

| Functor class used for generating key.

The documentation for this class was generated from the following files:

- Map_T.h
- Map_T.i